﻿using RimWorld;
using System.Collections.Generic;
using Verse;

namespace ChangeLook
{
    public class UnDisplay
    {
        public List<ThingDef> apparel = new List<ThingDef>();
        public bool displayHair = false;
        public bool displayHead = false;
        public bool displayEar = false;
    }
    public class DefaultHediff
    {
        public DefaultPropertyHediff defaultElementPropertyHediff = new DefaultPropertyHediff();
        public DefaultPropertyHediff defaultBodyTypePropertyHediff = new DefaultPropertyHediff();
    }

    public class DefaultPropertyHediff
    {
        public HediffDef hediffDefName;
        public List<HediffDef> ifPawnDoesntHaveTheseHeadifs = new List<HediffDef>();
    }

    public class PrefixAndPostfix
    {
        public string prefixOfHair = "";
        public string prefixOfHead = "";
        public string prefixOfBody = "";
        public string prefixOfHediff = "";
        public string postfixOfHediff = "";
    }
    public class Property
    {
        public List<PropertyName> element = new List<PropertyName>();
        public List<PropertyName> bodyType = new List<PropertyName>();
        public List<PropertyName> extra = new List<PropertyName>();
    }
    public class PropertyName
    {
        public List<HediffDef> hediffDefName;
        public string propertyName = "";
    }

    public class AgeProperty
    {
        public int min;
        public string ageTypeProperty = "";
        public List<ElementNumber> headElementNumber;
        public List<ElementNumber> hairElementNumber;
        public UnUsedProperty unUsedProperty = new UnUsedProperty();
    }

    public class UnUsedProperty
    {
        public UnUsed element = new UnUsed();
        public UnUsed bodyType = new UnUsed();
        public UnUsed extra = new UnUsed();
    }

    public class UnUsed
    {
        public List<string> unUsedList = new List<string>();
        public string elseUse = "";
    }

    public class ElementNumber
    {
        public string elementName;
        public int maxNumber;

        public List<ElementPostFix> elementPostFix = new List<ElementPostFix>();
    }

    public class ElementPostFix
    {
        public List<HediffDef> hediffDefName;
        public string elementPostFixName = "";
        public int maxNumber = 1;
    }
}