﻿using Verse;

namespace ChangeLook
{
    [StaticConstructorOnStartup]
    //대상 종족에 콤프 추가
    public class AddComp
    {
        static AddComp()
        {
            foreach (ChangeLookDef changeLook in DefDatabase<ChangeLookDef>.AllDefs)
            {
                changeLook.targetRace.comps.Add(new CompProperties(typeof(ThingComp_ChangeLook)));
            }
        }
    }

    //콤프
    public class ThingComp_ChangeLook : ThingComp
    {
        public bool bodycheck = false;
        public string becauseOf;
        public int chachedAgeBiologicalYears;

        public override void CompTick()
        {
            //민초 외형 변화
            if (Pawn != null && Pawn.Spawned && bodycheck)
            {
                foreach (ChangeLookDef changeLook in DefDatabase<ChangeLookDef>.AllDefs)
                {
                    if (changeLook.targetRace == Pawn.def)
                    {
                        if (ChangeLook_Setting.ChangeLookTestLog)
                        {
                            if (!becauseOf.NullOrEmpty())
                            {
                                Log.Error("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
                                Log.Error($"Change Look triggered by {becauseOf}");
                                Log.Error("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
                            }
                            else
                            {
                                Log.Error("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
                                Log.Error("Change Look triggered by Unknown reason");
                                Log.Error("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
                            }
                        }
                        changeLook.Changelook(Pawn);
                        bodycheck = false;
                        return;
                    }
                }
            }
        }
        public override void PostSpawnSetup(bool respawningAfterLoad)
        {
            base.PostSpawnSetup(respawningAfterLoad);
            Pawn = (parent as Pawn);
        }
        public Pawn Pawn { get; private set; }

    }
}
