﻿using RimWorld;
using Verse;

namespace Mincho_The_Mint_Choco_Slime
{
    public class CompProperties_CauseRemoveHediff_Apparel : CompProperties
    {
        public CompProperties_CauseRemoveHediff_Apparel()
        {
            this.compClass = typeof(CompCauseRemoveHediff_Apparel);
        }

        public HediffDef hediff;

        public BodyPartDef part;
    }

    public class CompCauseRemoveHediff_Apparel : ThingComp
    {
        private CompProperties_CauseRemoveHediff_Apparel Props
        {
            get
            {
                return (CompProperties_CauseRemoveHediff_Apparel)this.props;
            }
        }

        public override void Notify_Equipped(Pawn pawn)
        {
            if (pawn.health.hediffSet.GetFirstHediffOfDef(this.Props.hediff, false) == null)
            {
                HediffComp_RemoveIfApparelDropped hediffComp_RemoveIfApparelDropped = pawn.health.AddHediff(this.Props.hediff, pawn.health.hediffSet.GetNotMissingParts(BodyPartHeight.Undefined, BodyPartDepth.Undefined, null, null).FirstOrFallback((BodyPartRecord p) => p.def == this.Props.part, null), null, null).TryGetComp<HediffComp_RemoveIfApparelDropped>();
                if (hediffComp_RemoveIfApparelDropped != null)
                {
                    hediffComp_RemoveIfApparelDropped.wornApparel = (Apparel)this.parent;
                }
            }
        }

        public override void Notify_Unequipped(Pawn pawn)
        {
            base.Notify_Unequipped(pawn);
            Hediff firstHediffOfDef = pawn.health.hediffSet.GetFirstHediffOfDef(Props.hediff, false);
            if (firstHediffOfDef != null)
            {
                pawn.health.RemoveHediff(firstHediffOfDef);
            }
        }
    }
}
