﻿using HarmonyLib;
using RimWorld;
using System.Reflection;
using UnityEngine;
using Verse;

namespace Mincho_The_Mint_Choco_Slime
{
    [StaticConstructorOnStartup]
    internal static class Harmony_WornGraphicData
    {
        static Harmony_WornGraphicData()
        {
            Harmony harmony = new Harmony("Mincho_The_Mint_Choco_Slime");
            harmony.PatchAll(Assembly.GetExecutingAssembly());
        }
        [HarmonyPatch(typeof(WornGraphicData), "BeltScaleAt")]
        public class Harmony_BeltScaleAt
        {
            [HarmonyPrefix]
            public static bool BeltScaleAtPrefix(ref BodyTypeDef bodyType, ref Vector2 __result, ref WornGraphicData __instance)
            {
                __result = Vector2.one;
                bool flag = bodyType.defName.Contains("Mincho_Body_");
                bool result;
                if (flag)
                {
                    __result = __instance.female.Scale;
                    result = false;
                }
                else
                {
                    result = true;
                }
                return result;
            }
        }

        [HarmonyPatch(typeof(WornGraphicData), "BeltOffsetAt")]
        public class Harmony_BeltOffsetAt
        {
            [HarmonyPrefix]
            public static bool BeltOffsetAtPrefix(ref Rot4 facing, ref BodyTypeDef bodyType, ref Vector2 __result, ref WornGraphicData __instance)
            {
                bool flag = bodyType.defName.Contains("Mincho_Body_");
                bool result;
                if (flag)
                {
                    WornGraphicDirectionData wornGraphicDirectionData = default(WornGraphicDirectionData);
                    switch (facing.AsInt)
                    {
                        case 0:
                            wornGraphicDirectionData = __instance.north;
                            break;
                        case 1:
                            wornGraphicDirectionData = __instance.east;
                            break;
                        case 2:
                            wornGraphicDirectionData = __instance.south;
                            break;
                        case 3:
                            wornGraphicDirectionData = __instance.west;
                            break;
                    }
                    Vector2 vector = wornGraphicDirectionData.offset;
                    vector += wornGraphicDirectionData.female.offset;
                    __result = vector;
                    result = false;
                }
                else
                {
                    result = true;
                }
                return result;
            }
        }

    }
}
