﻿using HarmonyLib;
using RimWorld;
using System;
using System.Linq;
using Verse;

namespace WearSetting
{
    [StaticConstructorOnStartup]
    public static class Harmony_JobGiver_OptimizeApparel
    {
        static Harmony_JobGiver_OptimizeApparel()
        {
            var harmony = new Harmony("Mincho_The_Mint_Choco_Slime");

            harmony.Patch(AccessTools.Method(typeof(JobGiver_OptimizeApparel), "ApparelScoreGain", null, null), null, new HarmonyMethod(patchType, "ApparelScoreGainPostFix", null), null, null);
        }
        public static void ApparelScoreGainPostFix(Pawn pawn, Apparel ap, ref float __result)
        {
            if (__result < 0f)
            {
                return;
            }
            foreach (var (wearSetting, wearList) in from wearSettingDef in DefDatabase<WearSettingDef>.AllDefs
                                                    where pawn.def == wearSettingDef.targetRace
                                                    from wearSetting in wearSettingDef.wearSetting
                                                    from wearList in wearSetting.wearList
                                                    where ap.def == wearList
                                                    select (wearSetting, wearList))
            {

                WearSettingMethod.WearSettingBoolMaker(wearSetting,
                                                       pawn,
                                                       out WearSettingBool wearSettingBool,
                                                       out WearSettingBoolString wearSettingBoolString);

                if (wearSettingBool.cantWearBool)
                {
                    __result = -50f;
                }
            }
        }

        private static readonly Type patchType = typeof(Harmony_JobGiver_OptimizeApparel);
    }
}
