﻿using System.Collections.Generic;
using System.Linq;
using Verse;

namespace WearSetting
{
    public static class WearSettingMethod
    {
        public static void BoolString(string wearSettingBoolFalseString, string wearSettingBoolTrueString, bool canBool, out string boolString)
        {
            boolString = wearSettingBoolFalseString ?? "";
            if (canBool)
            {
                boolString = wearSettingBoolTrueString ?? "(V)";
            }

        }

        public static void WearSettingBoolMaker(WearSetting wearSetting, Pawn pawn, out WearSettingBool wearSettingBool, out WearSettingBoolString wearSettingBoolString)
        {
            Condition condition = wearSetting.condition;

            List<HediffDef> hediffDefs = (from pawnHediff in pawn.health.hediffSet.hediffs
                                          select pawnHediff.def).ToList();


            //나이
            bool age = condition.age.min <= pawn.ageTracker.AgeBiologicalYears && pawn.ageTracker.AgeBiologicalYears <= condition.age.max;

            //성별

            //바디타입

            //or헤디프

            //And 헤디프
            int match = 0;
            bool andHediff = false;
            if (condition.andHediffDef.NullOrEmpty())
            {
                andHediff = true;
            }
            else
            {
                foreach (var item in hediffDefs)
                {
                    if (condition.andHediffDef.Contains(item))
                    {
                        match++;
                    }
                }

                if (match >= condition.andHediffDef.Count)
                {
                    andHediff = true;
                }

            }

            //forbidden 헤디프
            bool forbiddenHediff = false;
            if (condition.forbiddenHediffDef.NullOrEmpty())
            {
                forbiddenHediff = false;
            }
            else foreach (var item in hediffDefs)
                {
                    if (condition.forbiddenHediffDef.Contains(item))
                    {
                        forbiddenHediff = true;
                        break;
                    }
                }

            //mustWearWith
            bool mustWearWith = false;
            if (condition.mustWearWith.NullOrEmpty())
            {
                mustWearWith = true;
            }
            else
            {
                foreach (var item in pawn.apparel.WornApparel)
                {
                    if (condition.mustWearWith.Contains(item.def))
                    {
                        mustWearWith = true;
                        break;
                    }
                }
            }


            bool forceDropHediffBool = ForceDropHediffBool(wearSetting, pawn);

            wearSettingBoolString = new WearSettingBoolString
            {
                genderString = ConditionCheck(pawn.gender, condition.gender, out bool gender),
                bodyTypeString = ConditionCheck(pawn.story.bodyType, condition.bodyTypeDef, out bool bodyType),
                orHediffString = ConditionCheck(hediffDefs, condition.orHediffDef, out bool orHediff),
                andHediffString = StringMaker(condition.andHediffDef),
                forbiddenHediffString = StringMaker(condition.forbiddenHediffDef),
                mustWearWithString = StringMaker(condition.mustWearWith)
            };



            wearSettingBool = new WearSettingBool
            {
                age = age,
                bodyType = bodyType,
                gender = gender,
                orHediff = orHediff,
                andHediff = andHediff,
                mustWearWith = mustWearWith,
                forbiddenHediff = forbiddenHediff,
                forceDropHediffBool = ForceDropHediffBool(wearSetting, pawn),
                cantWearBool = forceDropHediffBool || !age || !bodyType || !gender || !orHediff || !andHediff || !mustWearWith || forbiddenHediff,
                canWearBool = age && bodyType && gender && orHediff && andHediff && mustWearWith && !forbiddenHediff
            };
            ////디버그
            //Log.Error("cantWearBool : " + wearSettingBool.cantWearBool.ToString());
            //Log.Error("canWearBool : " + wearSettingBool.canWearBool.ToString());
            //Log.Error("forceDropHediffBool : " + forceDropHediffBool.ToString());
            //Log.Error("age : " + age.ToString());
            //Log.Error("bodyType : " + bodyType.ToString());
            //Log.Error("gender : " + gender.ToString());
            //Log.Error("orHediff : " + orHediff.ToString());
            //Log.Error("andHediff : " + andHediff.ToString());
            //Log.Error("forbiddenHediff : " + forbiddenHediff.ToString());
            //Log.Error("mustWearWith : " + mustWearWith.ToString());
        }

        private static string ConditionCheck<T>(T pawnCondition, List<T> conditionList, out bool Bool)
        {
            Bool = false;
            if (conditionList.NullOrEmpty())
            {
                Bool = true;
            }
            else foreach (var condition in conditionList)
                {
                    if (pawnCondition.Equals(condition))
                    {
                        Bool = true;
                        break;
                    }
                }
            return StringMaker(conditionList);
        }
        private static string ConditionCheck<T>(List<T> pawnConditionList, List<T> conditionList, out bool Bool)
        {
            Bool = false;
            if (conditionList.NullOrEmpty())
            {
                Bool = true;
            }
            else foreach (var condition in conditionList)
                {
                    if (pawnConditionList.Contains(condition))
                    {
                        Bool = true;
                        break;
                    }
                }
            return StringMaker(conditionList);
        }
        private static string StringMaker<T>(List<T> condition)
        {
            string conditionString = "";
            for (int i = 0; i < condition.Count; i++)
            {
                if (condition[i] is Def conditionDef)
                {
                    if (!conditionDef.LabelCap.NullOrEmpty())
                    {
                        if (i == condition.Count - 1)
                        {
                            conditionString += conditionDef.LabelCap;
                        }
                        else conditionString += conditionDef.LabelCap + "\n\n";
                    }
                    else
                    {
                        if (i == condition.Count - 1)
                        {
                            conditionString += condition[i].ToString();
                        }
                        else conditionString += condition[i].ToString() + "\n\n";
                    }
                }
                else
                {
                    if (i == condition.Count - 1)
                    {
                        conditionString += condition[i].ToString();
                    }
                    else conditionString += condition[i].ToString() + "\n\n";
                }
            }

            return conditionString;
        }
        public static bool ForceDropHediffBool(WearSetting wearSetting, Pawn pawn)
        {
            bool forceDropHediffBool = false;
            foreach (var forceDropHediff in wearSetting.forceDropHediff)
            {
                if (pawn.health.hediffSet.HasHediff(forceDropHediff, false))
                {
                    forceDropHediffBool = true;
                    break;
                }
            }

            return forceDropHediffBool;
        }

        public static TaggedString WearSettingTaggedString(string label, Thing thing, Pawn pawn, WearSetting wearSetting, WearSettingBoolString wearSettingBoolString)
        {
            return label.Translate(pawn.def.LabelCap,
                                   pawn.LabelShort,
                                   thing.def.LabelCap,
                                   wearSetting.condition.age.min,
                                   wearSetting.condition.age.max,
                                   wearSettingBoolString.genderString,
                                   wearSettingBoolString.bodyTypeString,
                                   wearSettingBoolString.orHediffString,
                                   wearSettingBoolString.andHediffString,
                                   wearSettingBoolString.forbiddenHediffString);
        }


    }
}
