﻿using System.Collections.Generic;
using Verse;

namespace ChangeLook
{
    public class HediffCompProperties_ChangeLook : HediffCompProperties
    {
        public List<HediffDef> healHediffDef = new List<HediffDef>();
        public HediffCompProperties_ChangeLook()
        {
            compClass = typeof(HediffComp_ChangeLook);
        }
    }
    public class HediffComp_ChangeLook : HediffComp
    {
        public HediffCompProperties_ChangeLook Props
        {
            get
            {
                return (HediffCompProperties_ChangeLook)props;
            }
        }
        public override void CompPostPostAdd(DamageInfo? dinfo)
        {
            foreach (ChangeLookDef changeLook in DefDatabase<ChangeLookDef>.AllDefs)
            {
                if (changeLook.targetRace == parent.pawn.def)
                {
                    base.CompPostPostAdd(dinfo);
                    changeLook.StartChangeLook(parent.pawn, "CompPostPostAdd");
                }
            }
        }

        public override void CompPostPostRemoved()
        {
            foreach (ChangeLookDef changeLook in DefDatabase<ChangeLookDef>.AllDefs)
            {
                if (changeLook.targetRace == parent.pawn.def)
                {
                    base.CompPostPostRemoved();
                    changeLook.StartChangeLook(parent.pawn, "CompPostPostRemoved");
                }
            }
        }
    }
}
