﻿using RimWorld;
using System.Collections.Generic;
using System.Linq;
using Verse;

namespace Mincho_The_Mint_Choco_Slime
{
    public class StockGenerator_Slaves_WithoutIdeologyMeme : StockGenerator_Slaves
    {
        public override IEnumerable<Thing> GenerateThings(int forTile, Faction faction = null)
        {
            if (this.respectPopulationIntent && Rand.Value > StorytellerUtilityPopulation.PopulationIntent)
            {
                yield break;
            }
            if (faction != null && faction.ideos != null)
            {
                bool flag = true;
                using (IEnumerator<Ideo> enumerator = faction.ideos.AllIdeos.GetEnumerator())
                {
                    while (enumerator.MoveNext())
                    {
                        if (!enumerator.Current.IdeoApprovesOfSlavery())
                        {
                            flag = false;
                            break;
                        }
                    }
                }
                if (!flag)
                {
                    yield break;
                }
            }
            int count = this.countRange.RandomInRange;
            int num;
            for (int i = 0; i < count; i = num + 1)
            {
                Faction faction2;
                if (!(from fac in Find.FactionManager.AllFactionsVisible
                      where fac != Faction.OfPlayer && fac.def.humanlikeFaction && !fac.temporary
                      select fac).TryRandomElement(out faction2))
                {
                    yield break;
                }
                DevelopmentalStage developmentalStages = Find.Storyteller.difficulty.ChildrenAllowed ? (DevelopmentalStage.Child | DevelopmentalStage.Adult) : DevelopmentalStage.Adult;
                PawnGenerationRequest request = new PawnGenerationRequest((this.slaveKindDef != null) ? this.slaveKindDef : PawnKindDefOf.Slave, faction2, PawnGenerationContext.NonPlayer, forTile, false, false, false, true, false, 1f, !this.trader.orbital, true, false, true, true, false, false, false, false, 0f, 0f, null, 1f, null, null, null, null, null, null, null, null, null, null, null, null, false, false, false, false, null, null, null, null, null, 0f, developmentalStages, null, null, null, false);
                yield return PawnGenerator.GeneratePawn(request);
                num = i;
            }
            yield break;
        }

        private bool respectPopulationIntent;
    }
}
